<!--
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
# 
# http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
#  KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
-->
## Release Notes for Cordova (Windows) ##

Update these notes using: git log --pretty=format:'* %s' --topo-order --no-merges *remote*/3.5.x...HEAD

cordova-windows is a library that enables developers to create Windows 8/8.1/10 and WP8.1 application projects that support Cordova APIs.

[4.1.0]
* CB-9499: Run failure targeting x64 with an x86 version of Node
* CB-8936: Logs: Stability and formatting improvements
* CB-8936: Windows logs: Improvements
* CB-9482: Mobile deployment failure 
* CB-9482: Mobile emulator deployment failure
* CB-8936: Added logging functionality
* CB-9458: Updated the baseline version of Universal Windows to 10240.
* CB-9456: Fixed windows app crash on startup
* CB-9450: `WindowsStoreIdentityName` preference for Store publishing
* CB-9455: Fixed requirements check failure
* CB-8965: Wait for project creation before adding to it.
* CB-8965: Copy cordova-js-src directory to platform folder during create
* CB-9359: Adds support for .appxbundle creation
* CB-9410: Added preferences for Windows Store ingestion.
* CB-9408: Added a `windows-packageVersion` attribute to the `<widget>` element 
* CB-9283: Add support for Windows 10 WinAppDeployCmd for deployment to remote devices.
* CB-9239: Fixes issue with windows prepare on posix platforms.
* CB-9235: Adds more checks based on the windows-target-version
* CB-9159: Fix WP8.1 deploy when 'window-target-version' is 10.0.
* CB-9335: Windows quality-of-life improvements.  
* put channel in its proper place, and removed comment. Removed extra )
* add same activated channel and activationContext for non-browserify workflows
* add activationContext + activated channel to windows
* CB-9271: Removed the unnecessary device capabilities from the Windows 10 app manifest. 
* CB-9252: Migrate WinJS to an NPM dependency
* Adding .ratignore file.
* CB-9164 Better error message when deploying to Windows10 phone emulator
* CB-9097: fail with a more descriptive error if run as admin

** Known Issues with 4.1.0 and Windows 10**

* The Windows 10 SDK includes a tool which can deploy to Windows 10 Phone, but not to a Windows 10 Phone Emulator.  To deploy to an emulator, open your solution file in Visual Studio.

[4.0.0]
* CB-8954 Adds `requirements` command support to check_reqs module
* CB-9073 Fixes build error when path to project contains `&` symbol
* CB-8889 Persist app/package name and product ID during platform update.
* Updating appx manifest to a large extent now happens in the `prepare` step as opposed to the `build` step. This change implies that cordova-windows 4.0.0 can only work with with cordova CLI > 5.0
* CB-8486 Support for creating signed package and build.json for Windows
* Add preview support for Windows 10 Universal Apps. To target Windows 10, add `<preference name="windows-target-version" value="10.0" />` to config.xml.
* The default windows target version is now 8.1.
* Support for `--appx` command line argument to override the windows target version
* CB-8946: Added the `WindowsToastCapable` preference to indicate that the app can support toasts.  This is to support the Local Notifications plugin.
* CB-8856 Fix 'Id' attribute is invalid when creating Windows Store submission build
* CB-8307: Adding a 25-year expiration temporary certificate.
* CB-8760 platform list doesn't show version for windows platform.

**Known Issues with 4.0.0 and Windows 10**

* Windows 10 Technical Preview 2 does not have a command-line compatible emulator deployment scenario.  To deploy to an emulator, open your solution file in Visual Studio.
* The Windows SDK included with Visual Studio 2015 RC does not include a tool to deploy to a Windows 10 Phone.  To deploy to a phone, open your solution file in Visual Studio.
* WinJS is included inline in the package.  In the future, it will be migrated to an NPM dependency. WinJS UI functionality is not included and should be add by you. (see [WinJS on Github](http://github.com/winjs/winjs)).

[3.8.2]
* Update cordova.js with a fix that causes Ripple emulation to fail.

[3.8.1]

* CB-8796 updated package.json version manually
* CB-8796 updated version file manually
* Removed verbose strict inequality tests
* Added check for undefined
* Fix for callback invocation with NO_RESULT
* Fixed wording of warning + removed a commented out line
* make bin scripts executable
* Update JS snapshot to version 3.8.1 (via coho)

[3.8.0]

* Update JS snapshot to version 3.8.0 (via coho)
* CB-7985 windows platform does not build with Visual Studio 14 CTP tools
* CB-8515 Support DefaultLanguage selection for Windows
* CB-8321 Add supported orientations config.xml preference handling for `windows` platform
* CB-8525 Fix audit-license-headers check on Windows
* CB-8400 Enable jshint for Windows platform and fix all jshint issues
* CB-8417 moved platform specific js into platform
* CB-8330 Added new unit tests
* CB-8136 Implemented prototype for end to end and unit tests via Jasmine
* Fixed regex used in getPackageFileInfo().

[3.7.1]

* Updated expired temporary certificate

[3.7.0]

* Update JS snapshot to version 3.7.0 (via coho)
* CB-7731 catch obvious missing args error
* CB-7493 Adds `space-in-path` and `unicode in name` tests for CI
* CB-7656 Fixes `list-devices` and `list-emulators` commands
* Fixes `msbuild` failure after **Windows** project creation
* CB-7617 partial match support for `--target`
* CB-7666 Merge `node_modules` and move to package root
* CB-7666 Move stuff outside of **Windows** subdir
* updated release notes for `3.6.4`
* CB-7617 Deploy on WP8.1 incorrectly handles `--target` name
* CB-7601 Build fails due to capabilities with m: prefixes are incorrectly sorted
* CB-7520 copy MRT images defined in config.xml
* CB-7520 `.appxbundle` package format support
* CB-7520 refine image names, use wildcard to include MRT images
* CB-7494 Fixes wrong replacements in `*.appxmanifest` files
* CB-7452 Windows. Rewrite `ApplyPlatformConfig.ps1` using NodeJS
* CB-7377 Removes unnecessary rules tracing which is also incorrectly handled by PS

[3.6.4]

* Set VERSION to 3.6.4 (via coho)
* Update JS snapshot to version 3.6.4 (via coho)
* CB-7617 partial match support for --target
* CB-7617 Deploy on WP8.1 incorrectly handles --target name
* bundledDependencies + fixed some whitespace

[3.6.0]

* CB-7377 Removes unnecessary rules tracing which is also incorrectly handled by PS
* update cordova.js
* Removed un-needed files, multiple cordova.js files can only cause confusion
* CB-7377 Whitelist. Windows build error due to 'invalid URI rules in config.xml'
* CB-7333 Makes default platform template files overridable
* Add appveyor badge
* CB-7129 VS2012 solution now accepts "anycpu" target instead of "any cpu"
* CB-7129 Fixes issue when project isn't built if msbuild v12.0 is not found.
* updated repo README
* updated repo README
* add appveyor file for ci
* add basic npm test of create+build project
* ignore node_modules
* CB-6976 Reflect new switch name to project structure
* CB-6976 Changes switch name from '--store' to '--win'
* Moves node_modules to bin to correctly work under npm
* Adds missing ExecutionPolicy option for powershell
* Configurable target version for store and phone targets.
* CB-7129 spellcheck
* Rewrite tooling/platform scripts from WSH to NodeJS
* CB-7243 VERSION file is copied over in create platform script.
* Using wildcard ** glob to include www folder items CB-6699 #32 #10
* CB-7144 Windows8 run fails if replace default certificate
* CB-6787 Windows8 - Fix header licenses (Apache RAT report)
* updated cordova.js
* CB-6976 support for new splash screen and icon images
* fixes potential perf issue inside exec_verbose method
* CB-6976 fixes deploy error when --nobuild option specified
* CB-6976 replaces new template icons and splash screens
* CB-6976 fixes deploy error on WP8.1 emulator
* CB-6976 fixes run/emulate error when it runs for the first time
* CB-6976 fixes deploy when target type is not specified
* Adds support for build archs to run command  + small cleanup and refactoring  + fix jshint issues
* CB-6976 Add support for Windows Universal apps (Windows 8.1 and WP 8.1)
* Cleanup. This closes #10
* Removed Windows7 which is now in it\'s own branch. This closes #29
* Added list of supported architectures in help text
* Adds support for target architectures to build command
* Closing merged pull requests. close #31, close #30
* Close stale pull-reqs, close #22, close #21, close #19
* CB-6686 [3.5.0rc][Windows8] Build  error if path contains whitespaces
* CB-6684 [3.5.0rc][Windows8] Splash screen setting breaks the build
* CB-6787 Add license to windows8/CONTRIBUTING.md
* CB-6684 [3.5.0rc][Windows8] Splash screen setting breaks the build
* CB-6686 [3.5.0rc][Windows8] Build  error if path contains whitespaces


[3.5.0]

* CB-6557: added pacakge.json to windows8
* CB-6491 add CONTRIBUTING.md
* CB-6309 Windows8. Add Splash Screen img support via config.xml preference, CB-6544 SplashScreenBackgroundColor, CB-6545 support multiple preferences
* moved PlatformConfig functionality to pre-build project level so running outside of cli will still work
* Fix for when background-color and/or content-src aren\'t specified in config.xml
* Background color now applied to windows 8 project config during build process. * Added logic to convert hexadecimal color to windows 8 specific format
* Fix build/deploy errors when path to project contains spaces
* Version files updated to 3.5.0-dev
* CB-6435 ./VERSION & /template/VERSION updated
* Modify execution policy restrictions removal logic. Using PS native cmdlet to remove restrictions.
* CB-6397 [windows8] Use the latest version of MSBuild Tools installed to build the app
* CB-6256 CB-6266 Add support for domain whitelist and start page settings to Windows8
* CB-2970 CB-2953 log unsupported methods and exit with code 1
* CB-2978 list-devices not supported on windows 8
* CB-6091 [windows] Build fails if application path contains whitespaces
* CB-6083 [windows8] Use registry to read msbuild tools path
* CB-6042 [windows8] Cordova emulate fails if no developer certificate is installed
* CB-5951 Added namespace to config.xml
* Remove template file after create by name
* CB-4533 return error code 2 on fail, CB-5359 get tools version from the registry
* update to 3.4.0 js and increment version num
* CB-5951 Added namespace to config.xml
* Remove template file after create by name
* CB-4533 return error code 2 on fail, CB-5359 get tools version from the registry
* update cordova-js and VERSION
